"""
GNU GPLv3-or-later
Lorenzo Mari - 2022

This file is part of Tor Space.

Tor Space is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software Foundation,
either version 3 of the License, or (at your option) any later version.

Tor Space is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Tor Space.
If not, see <https://www.gnu.org/licenses/>. 
"""

import rsa

def generate_keys():
	
    return rsa.newkeys(1024) # public, private


def encrypt(msg, key):
    return rsa.encrypt(msg.encode('utf-8'), key)


def decrypt(ciphertext, key):
    try:
        return rsa.decrypt(ciphertext, key).decode('utf-8')
    except:
        return False


def load(stuff):
	return rsa.PublicKey.load_pkcs1(stuff)



if __name__ == '__main__':
	public, private = generate_keys()
	print(decrypt(encrypt("Hello, World!", public), private))